# XZCompressorInputStream (Apache Commons Compress 1.13 API)

org.apache.commons.compress.compressors.xz

## Class XZCompressorInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.compress.compressors.CompressorInputStream
    - - org.apache.commons.compress.compressors.xz.XZCompressorInputStream

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public class XZCompressorInputStream
      extends CompressorInputStream

  XZ decompressor.
  Since:
    1.4

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `XZCompressorInputStream(InputStream inputStream)` Creates a new input stream that decompresses XZ-compressed data from the specified input stream.
    `XZCompressorInputStream(InputStream inputStream, boolean decompressConcatenated)` Creates a new input stream that decompresses XZ-compressed data from the specified input stream.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()`
    `void` | `close()`
    `static boolean` | `matches(byte[] signature, int length)` Checks if the signature matches what is expected for a .xz file.
    `int` | `read()`
    `int` | `read(byte[] buf, int off, int len)`
    `long` | `skip(long n)`

    - ### Methods inherited from class org.apache.commons.compress.compressors.CompressorInputStream

      `count, count, getBytesRead, getCount, pushedBackBytes`

    - ### Methods inherited from class java.io.InputStream

      `mark, markSupported, read, reset`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### XZCompressorInputStream

          public XZCompressorInputStream(InputStream inputStream)
                                  throws IOException

      Creates a new input stream that decompresses XZ-compressed data from the specified input stream. This doesn't support concatenated .xz files.
      Parameters:
        `inputStream` - where to read the compressed data
      Throws:
        `IOException` - if the input is not in the .xz format, the input is corrupt or truncated, the .xz headers specify options that are not supported by this implementation, or the underlying `inputStream` throws an exception

    - #### XZCompressorInputStream

          public XZCompressorInputStream(InputStream inputStream,
                                 boolean decompressConcatenated)
                                  throws IOException

      Creates a new input stream that decompresses XZ-compressed data from the specified input stream.
      Parameters:
        `inputStream` - where to read the compressed data
        `decompressConcatenated` - if true, decompress until the end of the input; if false, stop after the first .xz stream and leave the input position to point to the next byte after the .xz stream
      Throws:
        `IOException` - if the input is not in the .xz format, the input is corrupt or truncated, the .xz headers specify options that are not supported by this implementation, or the underlying `inputStream` throws an exception

  - ### Method Detail

    - #### matches

          public static boolean matches(byte[] signature,
                        int length)

      Checks if the signature matches what is expected for a .xz file.
      Parameters:
        `signature` - the bytes to check
        `length` - the number of bytes to check
      Returns:
        true if signature matches the .xz magic bytes, false otherwise

    - #### read

          public int read()
                   throws IOException

      Specified by:
        `read` in class `InputStream`
      Throws:
        `IOException`

    - #### read

          public int read(byte[] buf,
                 int off,
                 int len)
                   throws IOException

      Overrides:
        `read` in class `InputStream`
      Throws:
        `IOException`

    - #### skip

          public long skip(long n)
                    throws IOException

      Overrides:
        `skip` in class `InputStream`
      Throws:
        `IOException`

    - #### available

          public int available()
                        throws IOException

      Overrides:
        `available` in class `InputStream`
      Throws:
        `IOException`

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `InputStream`
      Throws:
        `IOException`

Copyright © 2016 The Apache Software Foundation. All rights reserved.